<ng-container *transloco="let t; read: 'moderate_users'">
  <div class="table-container">
    <mat-card appearance="outlined">
      <span class="table-header">{{t('approved_users')}}</span>
      <table
        class="table-width"
        mat-table
        matSort
        [dataSource]="dataSource">
        <!-- username -->
        <ng-container matColumnDef="username">
          <th
            *matHeaderCellDef
            mat-header-cell
            mat-sort-header>
            {{t('username_th')}}
          </th>
          <td
            *matCellDef="let row"
            mat-cell>
            {{row.username}}
          </td>
        </ng-container>
        <!-- roles -->
        <ng-container matColumnDef="roles">
          <th
            *matHeaderCellDef
            mat-header-cell
            mat-sort-header>
            {{t('roles_th')}}
          </th>
          <td
            *matCellDef="let row"
            mat-cell>
            <span
              class="inline-comma"
              *ngFor="let role of row.user_roles; last as l">
              {{'roles.'+role|transloco}}
              <span *ngIf="!l">, </span>
            </span>
          </td>
        </ng-container>
        <ng-container matColumnDef="status">
          <th
            *matHeaderCellDef
            mat-header-cell
            mat-sort-header>
            {{t('status_th')}}
          </th>
          <td
            *matCellDef="let row"
            mat-cell>
            <!-- TODO: change when account_states will be send from backend -->
            <div class="row-container">
              <div class="status-indicator" [ngClass]="row.is_active ? 'enabled_and_no_actions_required' : 'disabled'"></div>
              <div>{{'account_state.'+(row.is_active ? 'ENABLED_AND_NO_ACTIONS_REQUIRED' : 'DISABLED')|transloco}}</div>
            </div>
          </td>
        </ng-container>
        <!-- action buttons -->
        <ng-container matColumnDef="actions">
          <th
            *matHeaderCellDef
            mat-header-cell
            class="table-column-header-align-end">
            {{t('actions_th')}}
          </th>
          <td
            *matCellDef="let row"
            mat-cell
            class="action-menu-alignment">
            <button
              [mat-menu-trigger-for]="menu"
              mat-icon-button
              aria-label="Action dropdown menu">
              <mat-icon>more_vert</mat-icon>
            </button>
            <mat-menu #menu="matMenu">
              <button
                mat-menu-item
                (click)="showUserDetailsClicked.emit({ id: row.user_id })">
                <mat-icon>visibility</mat-icon>
                <span>{{t('show_details')}}</span>
              </button>
              <button
                mat-menu-item
                (click)="selectUserClicked.emit({ id: row.user_id })">
                <mat-icon>person</mat-icon>
                <span>{{t('select_user')}}</span>
              </button>
              <button
                mat-menu-item
                (click)="setUserRolesClicked.emit({ id: row.user_id })">
                <mat-icon>badge</mat-icon>
                <span>{{t('set_roles')}}</span>
              </button>
              <button
                mat-menu-item
                *ngIf="!row.is_active"
                (click)="activateUserClicked.emit({ id: row.user_id })">
                <mat-icon>swap_horiz</mat-icon>
                <span>{{t('activate')}}</span>
              </button>
              <button
                mat-menu-item
                *ngIf="row.is_active"
                (click)="deactivateUserClicked.emit({ id: row.user_id })">
                <mat-icon>compare_arrows</mat-icon>
                <span>{{t('deactivate')}}</span>
              </button>
            </mat-menu>
          </td>
        </ng-container>
        <tbody>
          <tr
            *matHeaderRowDef="displayColumns"
            mat-header-row>
          </tr>
          <tr
            *matRowDef="let row; columns: displayColumns;"
            mat-row [ngClass]="{'active-row': row.user_id === selectedUserId}">
          </tr>
           <!-- Row shown when there is no matching data. -->
           <tr
           class="mat-row no-data-table-row"
           *matNoDataRow>
           <td
             class="mat-cell"
             colspan="4">
             {{'general.no_data'|transloco}}
           </td>
         </tr>
        </tbody>
      </table>
    </mat-card>
  </div>
</ng-container>
